/* pivo passing implementation of Viterbi - very simple and not optimized */

#include <stdio.h>
#include <math.h>
#include "viterbi_pivo.h"
#include "common.h"
#include "lukas.h"

float viterbi (int N, int P, float **means, float **vars, float **trans,
	       float **fea, int T) {
  float *this, *next, a,b,token;
  int i,from,to,t; 

  this= Alloc_1_Float (N);  /* buffer with current tokens */
  next= Alloc_1_Float (N);  /* buffer with NEXT tokens */

  /* initialize the algorithm - inserting token in first all 
     entry states - means the 1st state */
  for (i=0; i<N; i++)
    this[i] = MINUS_INFTY;
  this[0] = 0; 
  //pfv ("this",this,N);

  /* run Viterbi - propagate tokens - for all times.  */
  for (t=0; t<T; t++) {

    ............. dopsat ................. 

    
    /* token passing for one time 't' is ready, next becomes this */
    for (i=0; i<N; i++)
      this[i] = next[i]; 

  } /* end for all times */
  
  /* finish the Viterbi - see what is connected to exit state and add just 
     the transition proba */
  next[N-1] = MINUS_INFTY;
  for (from=1; from < N-1; from++) { 
    token = this[from]; 
    if (token == MINUS_INFTY) continue; /* no token */
    a = trans[from][N-1];
    if (a == 0.0) continue;  /* no transition */ 
    token += log(a);  /* only trans proba, no emission */
    if (token > next[N-1]) next[N-1] = token;
  }

  return next[N-1];
}
    
